<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTDU_TipoDocIdentificacaoERP ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfTDU_TipoDocIdentificacaoERP
 * @subpackage Arrays
 */
class ArrayOfTDU_TipoDocIdentificacaoERP extends AbstractStructArrayBase
{
    /**
     * The TDU_TipoDocIdentificacaoERP
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TDU_TipoDocIdentificacaoERP[]
     */
    public $TDU_TipoDocIdentificacaoERP;
    /**
     * Constructor method for ArrayOfTDU_TipoDocIdentificacaoERP
     * @uses ArrayOfTDU_TipoDocIdentificacaoERP::setTDU_TipoDocIdentificacaoERP()
     * @param \StructType\TDU_TipoDocIdentificacaoERP[] $tDU_TipoDocIdentificacaoERP
     */
    public function __construct(array $tDU_TipoDocIdentificacaoERP = array())
    {
        $this
            ->setTDU_TipoDocIdentificacaoERP($tDU_TipoDocIdentificacaoERP);
    }
    /**
     * Get TDU_TipoDocIdentificacaoERP value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TDU_TipoDocIdentificacaoERP[]|null
     */
    public function getTDU_TipoDocIdentificacaoERP()
    {
        return isset($this->TDU_TipoDocIdentificacaoERP) ? $this->TDU_TipoDocIdentificacaoERP : null;
    }
    /**
     * Set TDU_TipoDocIdentificacaoERP value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TDU_TipoDocIdentificacaoERP[] $tDU_TipoDocIdentificacaoERP
     * @return \ArrayType\ArrayOfTDU_TipoDocIdentificacaoERP
     */
    public function setTDU_TipoDocIdentificacaoERP(array $tDU_TipoDocIdentificacaoERP = array())
    {
        foreach ($tDU_TipoDocIdentificacaoERP as $arrayOfTDU_TipoDocIdentificacaoERPTDU_TipoDocIdentificacaoERPItem) {
            // validation for constraint: itemType
            if (!$arrayOfTDU_TipoDocIdentificacaoERPTDU_TipoDocIdentificacaoERPItem instanceof \StructType\TDU_TipoDocIdentificacaoERP) {
                throw new \InvalidArgumentException(sprintf('The TDU_TipoDocIdentificacaoERP property can only contain items of \StructType\TDU_TipoDocIdentificacaoERP, "%s" given', is_object($arrayOfTDU_TipoDocIdentificacaoERPTDU_TipoDocIdentificacaoERPItem) ? get_class($arrayOfTDU_TipoDocIdentificacaoERPTDU_TipoDocIdentificacaoERPItem) : gettype($arrayOfTDU_TipoDocIdentificacaoERPTDU_TipoDocIdentificacaoERPItem)), __LINE__);
            }
        }
        if (is_null($tDU_TipoDocIdentificacaoERP) || (is_array($tDU_TipoDocIdentificacaoERP) && empty($tDU_TipoDocIdentificacaoERP))) {
            unset($this->TDU_TipoDocIdentificacaoERP);
        } else {
            $this->TDU_TipoDocIdentificacaoERP = $tDU_TipoDocIdentificacaoERP;
        }
        return $this;
    }
    /**
     * Add item to TDU_TipoDocIdentificacaoERP value
     * @throws \InvalidArgumentException
     * @param \StructType\TDU_TipoDocIdentificacaoERP $item
     * @return \ArrayType\ArrayOfTDU_TipoDocIdentificacaoERP
     */
    public function addToTDU_TipoDocIdentificacaoERP(\StructType\TDU_TipoDocIdentificacaoERP $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TDU_TipoDocIdentificacaoERP) {
            throw new \InvalidArgumentException(sprintf('The TDU_TipoDocIdentificacaoERP property can only contain items of \StructType\TDU_TipoDocIdentificacaoERP, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->TDU_TipoDocIdentificacaoERP[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TDU_TipoDocIdentificacaoERP|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TDU_TipoDocIdentificacaoERP|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TDU_TipoDocIdentificacaoERP|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TDU_TipoDocIdentificacaoERP|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TDU_TipoDocIdentificacaoERP|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TDU_TipoDocIdentificacaoERP
     */
    public function getAttributeName()
    {
        return 'TDU_TipoDocIdentificacaoERP';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfTDU_TipoDocIdentificacaoERP
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
